/*
 * JImage.java
 *
 * Created on 15 giugno 2011, 17.35
 */
package beans;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Insets;
import java.io.Serializable;
import javax.swing.JComponent;

/**
 * @author Gianfranco Oddenino
 */
public class JImage extends JComponent implements Serializable {

    private static final long serialVersionUID = 1L;
    private Image image = null;
    private Insets insets = null;
    private int w = 0, h = 0;

    public JImage() {
        setPreferredSize(new Dimension(100, 100));
        insets = getInsets();
        w = getWidth() - (insets.left + insets.right);
        h = getHeight() - (insets.top + insets.bottom);
    }

    public void clear() {
        if (image != null) {
            Graphics g = image.getGraphics();
            g.setColor(Color.WHITE);
            g.fillRect(0, 0, w, h);
            g.dispose();
            repaint();
        }
    }

    @Override
    protected void paintComponent(Graphics g) {
        super.paintComponent(g);
        insets = getInsets();
        int w1 = getWidth() - (insets.left + insets.right);
        int h1 = getHeight() - (insets.top + insets.bottom);
        if (image == null || w1 != w || h1 != h) {
            w = w1;
            h = h1;
            image = createImage(w, h);
            clear();
        }
        g.drawImage(image, insets.left, insets.top, null);
    }

    public Image getImage() {
        return image;
    }

    public void setImage(Image image) {
        this.image = image;
    }
}
