/*
 * JImagePanel.java
 *
 * Created on 20 maggio 2011, 21.21
 */
package beans;

import java.awt.Graphics;
import java.io.Serializable;
import javax.swing.Icon;
import javax.swing.JComponent;

/**
 * @author Gianfranco Oddenino
 */
public class JImagePanel extends JComponent implements Serializable {

    private Icon icon = null;
    private int iconX = 0, iconY = 0;

    @Override
    protected void paintComponent(Graphics g) {
        super.paintComponent(g);
        if (icon != null) {
            icon.paintIcon(this, g, iconX, iconY);
        }
    }

    public Icon getIcon() {
        return icon;
    }

    public void setIcon(Icon icon) {
        this.icon = icon;
        repaint();
    }

    public int getIconX() {
        return iconX;
    }

    public void setIconX(int iconX) {
        this.iconX = iconX;
        repaint();
    }

    public int getIconY() {
        return iconY;
    }

    public void setIconY(int iconY) {
        this.iconY = iconY;
        repaint();
    }

}
