/*
 * JTimer.java
 *
 * Created on 2 maggio 2011, 0.15
 */
package beans;

import java.io.Serializable;

/**
 * @author Gianfranco Oddenino
 */
public class JTimer extends Object implements Serializable {

    private int interval = 1000;
    private javax.swing.Timer timer = null;
    private transient java.awt.event.ActionListener actionListener = null;

    public JTimer() {
    }

    public int getInterval() {
        return interval;
    }

    public void setInterval(int value) {
        interval = value;
    }

    public synchronized void addActionListener(java.awt.event.ActionListener listener) {
        actionListener = listener;
    }

    public synchronized void removeActionListener(java.awt.event.ActionListener listener) {
        actionListener = null;
    }

    public void start() {
        if (timer == null) {
            timer = new javax.swing.Timer(interval, actionListener);
            timer.start();
        }
    }

    public void stop() {
        if (timer != null) {
            timer.stop();
            timer = null;
        }
    }

}
